#ifndef _MESSAGE_H__INCLUDED
#define _MESSAGE_H__INCLUDED

#include <stdio.h>
#include <sys/cdefs.h>

__BEGIN_DECLS

typedef enum
{
    V_SILENT = 0, // nothing at all
    V_ERRORS, // only errors
    V_WARNINGS, // errors and warnings
    V_VERBOSE // everything
} V_LEVEL;

extern void m_info(const char *fmt, ...); // print info message
extern void m_warning(const char *fmt, ...); // print warning message
extern void m_error(const char *fmt, ...); // print error message
extern void m_ferror(int status, const char *fmt, ...); // fatal error - print error message and call exit(status)
extern void m_set_fp(FILE *stdout_fp, FILE *stderr_fp); // set output file ptr to stdout_fp, error output file ptr to stderr_fp
extern void m_set_verbosity(V_LEVEL v); // set verbosity ( see enum V_LEVEL for possible verbosity levels )
extern V_LEVEL m_get_verbosity(void); // get verbosity ( see enum V_LEVEL for possible verbosity levels )

__END_DECLS

#endif
