#ifdef HAVE_CONFIG_H
#include "fix_configs.h"
#endif
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>
#include "parse.h"
#include "message.h"

char *aliases[3]= {"ring_users", "wall Hello", ""};
char *options[2]= {"Port", "2012"};

typedef struct
{
	char *name;
	char *cmd;
	char *user;
} alias_t;

typedef struct
{
    int option;
    char *arg;
} opt_t;

static int check_line_endings(FILE*);

int check_line_endings(FILE *fp)
{
    char c = 0, lastc = 0;
    while((c = fgetc(fp)) != EOF)
    {
        if((c == '\n') && (lastc != '\r'))
        {
			fseek(fp, -1, SEEK_CUR);
        }
        lastc = c;
    }
    return 0;
}

int parse(char *filename)
{
    FILE *fp = fopen(filename, "w+");
    if(fp == NULL)
    {
        return errno;
    }
    check_line_endings(fp);
    fclose(fp);
    fp = fopen(filename, "r");
    if(fp == NULL)
    {
        return errno;
    }
    int i = 0, tmp_opt_i = 0, pos = 0, retval = 0;
    char *tmp_opt, *x, c = '\0';
    bool eof_found = false;
    opt_t **options;
    opt_t **tmp;
    while(1) // this loop runs once per line
    {
        while(c = fgetc(fp))
        {
            if((c == '\r') || (c == EOF))
            {
                eof_found = true;
                break;
            }
            pos++;
        }
        if(eof_found) break;
        fseek(fp, (1-(pos+1)), SEEK_CUR);
        x = (char*) malloc(pos + 1);
        tmp_opt = (char*) malloc(pos + 1);
        c = fgetc(fp);
        if(c == '!')
        {
        	// option
        	errno = 0;
            retval = fscanf(fp, "%s %s\r\n", /*TODO option*/, /*TODO arg*/);
            if(retval != 2)
			{
				return errno;
			}
        }
        else if(c == '#')
        {
            // comment
        }
        else
        {
            // alias
        }
    }
    return 0;
}


int parse(char *filename)
{
	FILE *fp = NULL;
	fp = fopen(filename, "w+");
	if(fp == NULL)
	{
		return errno;
	}
	check_line_endings(fp);

}
